#include "indices.h"

int sub2ind(int dim, const int *size, const int *sub)
{
	int i, ind, stride;

	ind = 0;
	stride = 1;
	for(i = 0; i < dim; i++) {
    assert(sub[i] < size[i]);

		ind += stride * sub[i];
		stride *= size[i];
	}

	return ind;
}

void ind2sub(int dim, const int *size, int ind, int *sub)
{
	int i, stride, ind_orig;

  ind_orig = ind;

  for(i = 0; i < dim; i++) {
    sub[i] = ind % size[i];
    ind /= size[i];
  }

  assert(sub2ind(dim, size, sub) == ind_orig);
}

bool subiter(int dim, const int *size, int *sub)
{
  int i;

  for(i = 0; i < dim; i++) {
    sub[i]++;

    if(size[i] == sub[i]) {
      sub[i] = 0;
    }
    else {
      return true;
    }
  }

  return false;
}
