#include "mem.h"

void *memdup(size_t s, const void *src)
{
  void *dst;

  if(src == NULL) {
    return NULL;
  }

  dst = malloc(s);
  memcpy(dst, src, s);

  return dst;
}

void *memmultilloc(size_t nptrs, ...)
{
  va_list args;
  size_t i, s;
  void *mem, **out;
  uintptr_t p;

  // Get total allocation
  va_start(args, nptrs);
  s = 0;
  for(i = 0; i < nptrs; i++) {
    s += va_arg(args, size_t);
    va_arg(args, void **);
  }
  va_end(args);

  // Allocate
  mem = malloc(s);

  // Set individual pointers
  p = (uintptr_t)mem;
  for(i = 0; i < nptrs; i++) {
    s = va_arg(args, size_t);

    out = va_arg(args, void **);
    *out = (void *)p;

    p += s;
  }

  return mem;
}
