#ifndef __SHUFFLE_H__
#define __SHUFFLE_H__

/**
 * Randomly shuffle the order of the contents of an array.
 *
 * @arg @c n Then number of elements in @c x.
 * @arg @c x An initial array.
 * @arg @c seed Seed to use in random number generation.  Will be modified
 *              randomly.
 *              If NULL, uses the non-thread-safe @c rand function.
 */
void shuffle(int n, int *x, unsigned *seed);

#endif // #ifndef __SHUFFLE_H__
