% [x status] = boxqp(Q, c, l, u, x0, opts);
%
%   Solve the bound-constrained QP
%
%   min_x   1/2 * x' * Q * x + c' * x
%   s.t.    x <= l < = u
%
%   using the GPCG algorithm.  Q must be a sparse matrix.
%
%   opts: Options struct passed to the GPCG algorithm.  Has the fields:
%     'grad_norm': Projected gradient norm at which to stop iterations.
%     'max_iters': Maximum number of search directions.
%     'eta1': The progress ratio at which to switch from conjugate gradient
%             to gradient search directions.
%     'eta2': The progress ratio at which to switch from gradient top
%             conjugate gradient search directions.
%
%  TODO: citation