n = 1024;

% Construct sparse PSD Q
Qnnz = 4*n;

i = randsample(n, Qnnz, true);
j = randsample(n, Qnnz, true);
v = rand(Qnnz, 1);

Q = sparse(i, j, v, n, n);
Q = (Q + Q')/2;
Q = Q + diag(sum(abs(Q)));

c = rand(n, 1);

% Construct random constraints and initial feasible point
opt = Q \ c;

active = rand(n, 1);
active_lower = active < 1/3;
interior = active >= 1/3 & active <= 2/3;
active_upper = active > 2/3;

nl = sum(active_lower);
ni = sum(interior);
nu = sum(active_upper);

l = zeros(n, 1);
u = zeros(n, 1);

l(active_lower) = opt(active_lower) + rand(nl, 1);
u(active_lower) = l(active_lower) + rand(nl, 1);

l(interior) = opt(interior) - rand(ni, 1);
u(interior) = opt(interior) + rand(ni, 1);

u(active_upper) = opt(active_upper) - rand(nu, 1);
l(active_upper) = u(active_upper) - rand(nu, 1);

% Construct an H matrix
m = 100;
Hi = randsample(1:m, n, true);
Hj = 1:n;
Hv = ones(n, 1);
H = sparse(Hi, Hj, Hv, m, n);

lambda = 1e-1;
H = lambda * H;

% Alias Q to L
L = Q;

save prob.mat Q c u l L H
