load prob.mat
x0 = l;

opts = struct('grad_norm', 1e-5, 'max_iters', 100);

%[x status] = boxqp(Q, c, l, u, x0, opts);
[x status] = rwprior(L, H, c, l, u, x0, opts);
status

% Check projected gradient
h = H * x;
obj = x' * L * x + h' * h + c' * x
%projg = Q*x+c;
projg = 2 * (L * x + H' * (H * x)) + c;
projg(projg > 0 & x <= l + 1e-6) = 0;
projg(projg < 0 & x >= u - 1e-6) = 0;
fprintf(1, 'Projected gradient infnorm: %e\n', max(abs(projg)))

% Check feasibility
infeas = max([x - u; l - x; 0]);
fprintf(1, 'Infeasibility: %e\n', infeas);
