from SCons.Script import *
import SCons.Tool

import os, os.path, sys, subprocess
import re

# Load project-local site_scons
site_scons_dir = Dir('site_scons').abspath
sys.path = [site_scons_dir] + sys.path

site_tools_dir = Dir('site_scons/site_tools').abspath
SCons.Tool.DefaultToolpath = [site_tools_dir] + SCons.Tool.DefaultToolpath

def svnRoot():
    svn_root_re = re.compile('Repository Root:\s+(.*?)\s+')
    proc = subprocess.Popen(['svn', 'info'], stdout = subprocess.PIPE)
    for line in proc.stdout:
        m = svn_root_re.match(line)
        if m:
            svn_root = m.groups()[0]
            svn_root = svn_root[:svn_root.rfind('/')+1]

    return svn_root

# Load common toolbox
try:
    Import('__common_toolbox_loaded')
except:
    # Check toolbox out of SVN
    svn_url = 'research/util/toolbox/trunk'
    path = os.path.join(Dir('.').abspath, 'site_scons/toolbox')

    try:
        if os.path.exists(path):
            cmd = ['svn', 'update', path]
        else:
            cmd = ['svn', 'checkout', svnRoot() + svn_url, path]
        
        print ' '.join(cmd)
        if not GetOption('clean'):
            subprocess.call(cmd)
            
        # Add to tool path
        SCons.Tool.DefaultToolpath = [path] + SCons.Tool.DefaultToolpath
    except:
        pass # Ignore failures


    __common_toolbox_loaded = True
    Export('__common_toolbox_loaded')
