from SCons.Script import *

builders = ['StaticObject']
exts = ['.c']

def generate(env):
    # Environment to pass appropriate flag for each '-include' variable
    env['CINCLUDE'] = []
    env['CINCLUDEFLAG'] = '-include'
    env.Append(CFLAGS = ['${_INCLUDEFLAGS(CINCLUDE, CINCLUDEFLAG, __env__)}'])

    env['CXXINCLUDE'] = []
    env['CXXINCLUDEFLAG'] = '-include'
    env.Append(CXXFLAGS = ['${_INCLUDEFLAGS(CXXINCLUDE, CXXINCLUDEFLAG, __env__)}'])

    # Function to build '-include' flags in commands
    def includeFlags(includes, flag, env):
        ls = []

        for inc in includes:
            ls.extend([flag, inc])

        return ls
    env['_INCLUDEFLAGS'] = includeFlags

    # Replace scanner with ones that append env['INCLUDE']
    for builder in ['StaticObject']:
        scanner = env['BUILDERS'][builder].source_scanner.function

        for ext in exts:
            old_function = scanner[ext].function

            def _scan(node, env, path):
                l = old_function(node, env, path)

                if 'CINCLUDE' in env:
                    l += env['CINCLUDE']

                return l

            scanner[ext].function = _scan


def exists(env):
    # TODO: check that this is gcc?
    return True
