import SCons, SCons.Action, SCons.Builder
from SCons.Script import *

"""A builder to generate static libraries from PIC code.

   Really just copies the StaticLibrary builder, but pulls the sources
   that SharedLibrary uses.
"""

def generate(env):
    env['PICLIBPREFIX'] = '$LIBPREFIX'
    env['PICLIBSUFFIX'] = '$LIBSUFFIX'
    env['PICOBJSUFFIX'] = '$SHOBJSUFFIX'

    shlib = env['BUILDERS']['SharedObject']

    pic_lib = env.Builder(action = env['BUILDERS']['StaticLibrary'].action,
                          emitter = shlib.emitter,
                          prefix = '$PICLIBPREFIX',
                          suffix = '$PICLIBSUFFIX',
                          src_suffix = '$PICOBJSUFFIX',
                          src_builder = 'SharedObject')
    env['BUILDERS']['PICLibrary'] = pic_lib

def exists(env):
    pass
