from SCons.Script import *

restrict_test_file = """
#include <stdio.h>

int main(int argc, char **argv)
{
  int * restrict x;

  x = &argc;

  return 0;
}
"""

def CheckRestrictKeyword(context):
    context.Message('Checking for "restrict" keyword... ')
    result = context.TryCompile(restrict_test_file, '.c')
    context.Result(result)
    return result

def generate(env):
    conf = Configure(env, custom_tests = {'CheckRestrictKeyword' : CheckRestrictKeyword})

    if not conf.CheckRestrictKeyword():
        env.Append(CPPDEFINES = [('restrict', '')])

    conf.Finish()

def exists(env):
    return True
