#define KERNEL_NAME2(func) func ## _kernel
#define KERNEL_NAME(func) KERNEL_NAME2(func)

static __global__ void KERNEL_NAME(FUNC)(int n, DST_ELT *dst, const SRC_ELT *src)
{
  int i;

  // Get index
  i = blockDim.x * blockIdx.x + threadIdx.x;
  if(i >= n) {
    return;
  }

  dst[i] = (CAST((src[i])));
}

extern "C" void FUNC(int n, DST_ELT *dst, const SRC_ELT *src)
{
  int device, threads, blocks;
  cudaDeviceProp devprops;
  int stride;

  cudaGetDevice(&device);
  cudaGetDeviceProperties(&devprops, device);
  threads = devprops.maxThreadsPerBlock;
  blocks = devprops.maxGridSize[0];
  stride = threads * blocks;

  while(n > 0) {
    KERNEL_NAME(FUNC)<<<blocks, threads>>>(n, dst, src);

    dst += stride;
    src += stride;

    n -= stride;
  }
}

#undef CAST
#undef FUNC
#undef DST_ELT
#undef SRC_ELT

#undef KERNEL_NAME
#undef KERNEL_NAME2
