#ifndef __GPU_CONVERT_H__
#define __GPU_CONVERT_H__

#include <cublas.h>

#include "../status.h"
#include "../matrix_description.h"

#ifdef __cplusplus
extern "C" {
#endif

void gpu_StoD(int n, double *dst, const float *src);
void gpu_StoC(int n, cuComplex *dst, const float *src);
void gpu_StoZ(int n, cuDoubleComplex *dst, const float *src);

void gpu_DtoS(int n, float *dst, const double *src);
void gpu_DtoC(int n, cuComplex *dst, const double *src);
void gpu_DtoZ(int n, cuDoubleComplex *dst, const double *src);

void gpu_CtoZ(int n, cuDoubleComplex *dst, const cuComplex *src);
void gpu_ZtoC(int n, cuComplex *dst, const cuDoubleComplex *src);

size_t gpu_type_length(int count, linalg_elt_type_t type);
linalg_status_t gpu_convert(int n,
  linalg_elt_type_t dst_type, void *dst,
  linalg_elt_type_t src_type, const void *src);

#ifdef __cplusplus
}
#endif

#endif // #ifndef __GPU_CONVERT_H__
