#ifndef __LINALG_GPU_H__
#define __LINALG_GPU_H__

#include "../vector.h"
#include "../matrix.h"

#include <cusparse.h>

vector_t *vector_gpu_create(const matdesc_t *desc, int length);

matrix_t *matrix_gpu_create_full(linalg_elt_type_t type, int ndims, const int *dims, int nnz);
matrix_t *matrix_gpu_create_csc(cusparseHandle_t cusparse, linalg_elt_type_t type, int rows, int cols, int nnz);
matrix_t *matrix_gpu_create_csr(cusparseHandle_t cusparse, linalg_elt_type_t type, int rows, int cols, int nnz);
matrix_t *matrix_gpu_create_coo(cusparseHandle_t cusparse, linalg_elt_type_t type, int ndims, const int *dims, int nnz);

#endif // #ifndef __LINALG_GPU_H__
