#ifndef __MATRIX_INTERNAL_H__
#define __MATRIX_INTERNAL_H__

#include "matrix.h"

typedef struct matrix_vtable matrix_vtable_t;

struct matrix
{
	const matrix_vtable_t *v;

	bool gpu;
	matrix_storage_format_t format;
	linalg_elt_type_t type;

	int ndims;
	int *dims;
};

struct matrix_vtable
{
	matrix_t *(*clone)(const matrix_t *base);
	void (*destroy)(matrix_t *base);

	matrix_t *(*from_gpu)(const matrix_t *base);
	matrix_t *(*to_gpu)(const matrix_t *base);

	matrix_t *(*to_full)(const matrix_t *base);
	matrix_t *(*to_csc)(const matrix_t *base);
	matrix_t *(*to_csr)(const matrix_t *base);
	matrix_t *(*to_coo)(const matrix_t *base);

	matrix_t *(*to_elt_type)(const matrix_t *base, linalg_elt_type_t type);

	int (*nnz)(const matrix_t *base);
};

#endif // #ifndef __MATRIX_INTERNAL_H__
