#ifndef __LINALG_PLAIN_CONVERT_H__
#define __LINALG_PLAIN_CONVERT_H__

#include <stdlib.h>
#include <f2c.h>
#include <memory.h>

#include "../matrix_description.h"
#include "../status.h"

void plain_StoD(int n, double *dst, const float *src);
void plain_StoC(int n, complex *dst, const float *src);
void plain_StoZ(int n, doublecomplex *dst, const float *src);

void plain_DtoS(int n, float *dst, const double *src);
void plain_DtoC(int n, complex *dst, const double *src);
void plain_DtoZ(int n, doublecomplex *dst, const double *src);

void plain_CtoZ(int n, doublecomplex *dst, const complex *src);
void plain_ZtoC(int n, complex *dst, const doublecomplex *src);

size_t plain_type_length(int count, linalg_elt_type_t type);
linalg_status_t plain_convert(int n,
  linalg_elt_type_t dst_type, void *dst,
  linalg_elt_type_t src_type, const void *src);

#endif // #ifndef __LINALG_PLAIN_CONVERT_H__
