#ifndef __LINALG_SCALAR_H__
#define __LINALG_SCALAR_H__

static inline double StoD(float x)
{
  return (double)x;
}

static inline complex StoC(float x)
{
  complex c;

  c.r = x;
  c.i = 0;

  return c;
}

static inline doublecomplex StoZ(float x)
{
  doublecomplex z;

  z.r = (double)x;
  z.i = 0;

  return z;
}

static inline float DtoS(double x)
{
  return (float)x;
}

static inline complex DtoC(double x)
{
  complex c;

  c.r = (float)x;
  c.i = 0;

  return c;
}

static inline doublecomplex DtoZ(double x)
{
  doublecomplex z;

  z.r = x;
  z.i = 0;

  return z;
}

static inline doublecomplex CtoZ(complex c)
{
  doublecomplex z;

  z.r = (double)c.r;
  z.i = (double)c.i;

  return z;
}

static inline complex ZtoC(doublecomplex z)
{
  complex c;

  c.r = (float)z.r;
  c.i = (float)z.i;

  return c;
}

#endif // #ifndef __LINALG_SCALAR_H__
