#include "norm.h"

#include <cuda_runtime.h>
#include <cublas.h>

#include <stdio.h>

double l1_normf_gpu(int n, const double *x)
{
  return cublasDasum(n, x, 1);
}

double l2_normf_gpu(int n, const double *x)
{
  return cublasDnrm2(n, x, 1);
}

double linfty_normf_gpu(int n, const double *x)
{
  int i;
  double amax;

  // Find maximum
  i = cublasIdamax(n, x, 1)-1;

  // Retrieve result to host
  cudaMemcpy(&amax, x + i, sizeof(double), cudaMemcpyDeviceToHost);

  return fabsf(amax);
}
