#ifndef __GRAD_PROJ_GPU_PROJECT_H__
#define __GRAD_PROJ_GPU_PROJECT_H__

#include <cuda_runtime.h>

#ifdef __cplusplus
extern "C" {
#endif

///////////////////////// Point Projection //////////////////////

void boxproject(int n, double *x, const double *l, const double *u);

void boxproject_gpu(int n, double *x, const double *l, const double *u, const struct cudaDeviceProp *devprops);


/////////////////////// Direction Projection ////////////////////

void boxproject_direction(int n, double *d, const double *x, const double *l, const double *u);

void boxproject_direction_gpu(int n, double *d, const double *x, const double *l, const double *u, struct cudaDeviceProp *devprops);

//////////////////////////// Breakpoints //////////////////////////

double boxproject_breakpoint(int n, const double *x, const double *d, const double *l, const double *u);

double boxproject_breakpoint_gpu(int n, const double *x, const double *d, const double *l, const double *u, double *b, struct cudaDeviceProp *devprop);

#ifdef __cplusplus
}
#endif

#endif // #ifndef __GRAD_PROJ_GPU_PROJECT_H__
