#include "runparams.h"


runparams_t runparams(int n, const struct cudaDeviceProp *devprops)
{
	runparams_t p;

  p.threads = devprops->maxThreadsPerBlock;
	if(p.threads > n) {
		p.threads = n;
		p.blocks = 1;
		p.stride = n;
		return p;
	}

  p.blocks = devprops->maxGridSize[0];
  p.stride = p.threads * p.blocks;
	if(p.stride > n) {
		p.blocks = (n + p.threads - 1) / p.threads;
		p.stride = p.threads * p.blocks;
	}

	return p;
}
